<?php

namespace App\Http\Controllers\Admin;

use App\Model\Data;
use App\Model\User;
use Illuminate\Http\Request;

use App\Http\Requests;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\DB;
use Maatwebsite\Excel\Facades\Excel;

class SqlController extends CommonController
{

    public function index()
    {
        $data = Data::all();
        return view('admin.sql.index',compact('data'));

    }

    public function backups(Request $request)
    {
        //生成备份文件夹
        $excle_path = date('YmdHis');

        //数据库所有表
        $tables = DB::select('SHOW TABLES');
        $tables =  json_decode( json_encode( $tables),true);
        $table_name = array();
        foreach($tables as $k => $v){
            $table_name[] = $v['Tables_in_zcju'];
        }
        //循环查表导出为excle文件
        foreach($table_name as $value){
            $data = DB::table($value)->get();
            $data =  json_decode( json_encode( $data),true);
            Excel::create($value,function($excle) use ($data){
                $excle->sheet('score',function($sheet) use ($data){
                    $sheet->rows($data);
                });
            })->store('xls',storage_path('databases/'.$excle_path.'_'.$request->all()['name']));
        }
        $this->mkFolder(storage_path('databases/'));
        //存datas表
        $input = $request->all();
        $input['path'] = $excle_path.'_'.$input['name'] ;
        if(Data::create($input)){
            return redirect('/sql');
        }
        return 1;
    }

    public function recovery($id)
    {

    }

    public function download($id)
    {

    }

//    修改文件夹权限
    protected static function mkFolder($path)
    {

        if (!is_readable($path)) {

            mkdir($path, 0777, true);

        }

    }

}
